Procedure PutPix8(x,y:word;color:word; where:TPageType);
begin
  {mem[Where.seg+x+y*Where.SizeX]:=byte(color);}
  asm

--    xor eax,eax
--    xor edx,edx
    mov ax,y
    mov dx,word ptr Where[4]
    mul edx

    mov edi,dword ptr Where
    add edi,eax
    mov dx,x
    add edi,edx

    mov al,byte ptr color
    mov [edi],al
  end;

end;
Function GetPix8(x,y:word; where:TPageType):word;
  begin
   asm
    mov ax,y
    mov dx,word ptr Where[4]
    mul edx

    mov edi,dword ptr Where
    add edi,eax
    mov dx,x
    add edi,edx

    xor ax,ax
    mov al,[edi]
   end;
  end;

Procedure Line8(x1,y1,x2,y2,color:word;Where:TPageType);
   function sign(a:longint):longint;assembler;
      asm
        mov eax,a
        and eax,eax
        jns @@1
        jz  @@zero
        mov eax,-1
        jmp @@2
  @@zero:
        mov eax,0
        jmp @@2
  @@1:
        mov eax,1
  @@2:
      end;

var xlen,ylen,xStep,yStep:fixed;
    startX,startY,endX,endY,currX,currY:fixed;
    xstep2:fixed;
    {xdir,}ydir:longint;
    x,y:integer;
    offs:dword;
    temp:integer;
begin
  xlen:=abs(x2-x1)+1;
  ylen:=abs(y2-y1)+1;
  if xlen>ylen then begin
         -- go from right to left --
         if x2>x1 then begin
            temp:=x1;
            x1:=x2;
            x2:=temp;
            temp:=y1;
            y1:=y2;
            y2:=temp;
            {xdir:=-xdir;}
         end;

         ydir:=sign(y2-y1);
         xStep:=mFixedDiv(ylen shl 16,xlen shl 16);

         yStep:=Where.SizeX*ydir;
         asm
           cld

           mov edi,dword ptr Where  -- calculate offset of line begining
           sub eax,eax
           mov ax,y1
           sub ecx,ecx
           mov cx,word ptr Where[4]
           mul ecx
           add edi,eax
           mov cx,x1
           add edi,ecx

           mov edx,xStep
           mov al,byte ptr color

           mov ecx,xlen        -- put first dot

           sub edi,ecx
           xor bx,bx
           mov [edi+ecx],al
           dec ecx

  @@drawHLine2:
           add     bx,dx       -- yFrac:=yFrac+yFracStep
           jnc     @@cont2
           add     edi,yStep   -- go to next line
  @@cont2:
           mov     [edi+ecx],al
           dec ecx
           jnz @@DrawHLine2
--           loop    @@DrawHLine2
         end;
  end
  else if ylen>xlen then begin
         -- go from left to right --
         if x1>x2 then begin
            temp:=x1;
            x1:=x2;
            x2:=temp;
            temp:=y1;
            y1:=y2;
            y2:=temp;
         end;
         ydir:=sign(y2-y1);
         yStep:=mFixedDiv(xlen shl 16,ylen shl 16);

         xStep:=Where.SizeX*ydir;
         asm
           cld

           mov edi,dword ptr Where  -- calculate offset of line begining
           sub eax,eax
           mov ax,y1
           sub ecx,ecx
           mov cx,word ptr Where[4]
           mul ecx
           add edi,eax
           mov cx,x1
           add edi,ecx

           mov edx,yStep
           mov al,byte ptr color
           mov ecx,ylen

           xor bx,bx
           mov [edi],al
           dec ecx
   @@vloop:
           add     bx,dx
           adc     edi,xStep
           mov     [edi],al
           dec ecx
           jnz @@vloop
--           loop    @@vloop
         end;
  end;
end;

Procedure Bar8(x1,y1,x2,y2,color:word;Where:TPageType);
var
    tmp:word;
    yadd:longint;
    sizeX,SizeY:word;
begin
   if x1>x2 then begin
      tmp:=x1; x1:=x2; x2:=tmp;
      tmp:=y1; y1:=y2; y2:=tmp;
   end;
   SizeX:=x2-x1;
   SizeY:=abs(y2-y1)+1;
   if y1>y2 then yadd:=-(Where.SizeX+sizeX) else yadd:=Where.SizeX-SizeX;

   asm
     cld

     mov edi,dword ptr Where  -- calculate starting offset
     sub eax,eax
     mov ax,y1
     sub ecx,ecx
     mov cx,word ptr Where[4]
     mul ecx
     add edi,eax
     mov cx,x1
     add edi,ecx

     mov al,byte ptr color
     mov ah,al
     mov dx,ax
     shl eax,16
     mov ax,dx

     mov cx,SizeX
     mov dx,cx
     mov bx,SizeY
     mov esi,yadd

   @@looper:
  -- draw horizontal line
     shr cx,1
     jnc @@FillW
     stosb
   @@FillW:
     shr cx,1
     jnc @@FillD
     stosw
   @@FillD:
     rep stosd

     add edi,esi     -- offs+:=yadd
     mov cx,dx       -- restore line size
     dec bx          -- Ysize-:=1;
     jnz @@looper
   @@nodraw:
   end;

end;