(**********************************************************************)
(*                                                                    *)
(*  This part of SVGALIB v1.0 enhance standart mouse unit for working *)
(*  in SVGA modes                                                     *)
(*                                                                    *)
(**********************************************************************)
Var MPtr:TMousePointer;
    MaxX,MaxY,MinX,MinY:integer;
    OldX,OldY,OldWinX,OldWinY:integer;
    WhereDraw:TPageType;
{
Procedure DrawMousePointer(x,y:integer);
 var a,b:integer;
     offs:dword;
     moffs:integer;
     xadd:dword;
 begin
    offs:=WhereDraw.seg+(y*WhereDraw.SizeX+x)*BytesPerPixel;
    mOffs:=0;
    xadd:=(WhereDraw.SizeX-MPtr.SizeX)*BytesPerPixel;
    for a:=1 to MPtr.SizeY do begin
        for b:=1 to MPtr.SizeX do begin
            if MPtr.Buf^[moffs]<>MPtr.TranspColor then
                    mem[offs]:=MPtr.Buf^[moffs];
            moffs:=moffs+BytesPerPixel;
            offs:=offs+BytesPerPixel;
        end;
        offs:=offs+xadd;
    end;
 end;
}
Procedure DrawMousePointer(x,y:integer);
 var a,b:integer;
     offs:dword;
     moffs:integer;
     xadd:dword;
     RealCursSizeX:integer;
     RealCursSizeY:integer;
     padd:dword;
     YSizeOnSplitScrn:integer;
     StartYOnSplitScrn:integer;
     CursSizeX,CursSizeY:integer;
     SplitScrnDraw:boolean;
 begin
    CursSizeX:=MPtr.SizeX;
    CursSizeY:=MPtr.SizeY;
    SplitScrnDraw:=false;

    offs:=WhereDraw.seg+(y*WhereDraw.SizeX+x)*BytesPerPixel;
    moffs:=0;

    if (x+CursSizeX)>ScrnSizeX then begin
       RealCursSizeX:=ScrnSizeX-x;
       padd:=CursSizeX-RealCursSizeX;
    end
    else begin
       RealCursSizeX:=CursSizeX;
       padd:=0;
    end;
    if (y+CursSizeY)>ScrnSizeY then RealCursSizeY:=ScrnSizeY-y
      else RealCursSizeY:=CursSizeY;

    if (SplitScrnActive AND DrawOverSplitScreen) then
{if cursor go over split screen, then we must draw part of cursor on split screen}
       if (y+RealCursSizeY)>SplitScrnScanLine then begin
          SplitScrnDraw:=True;
          {calculate number of rows must be displayed on split screen}
          YSizeOnSplitScrn:=RealCursSizeY-(SplitScrnScanLine-y);

          {all cursor located on split screen}
          if YSizeOnSplitScrn>RealCursSizeY then begin
             --RealCursSizeY:=SplitScrnScanLine-y;
             YSizeOnSplitScrn:=RealCursSizeY;
             RealCursSizeY:=0;
             StartYOnSplitScrn:=y-SplitScrnScanLine-1;
          end
          else begin
             StartYOnSplitScrn:=0;
--             YSizeOnSplitScrn-:=3;
             YSizeOnSplitScrn-:=1;
             RealCursSizeY:=RealCursSizeY-YSizeOnSplitScrn;
          end;
       end;



    xadd:=(WhereDraw.SizeX-RealCursSizeX);
    for a:=1 to RealCursSizeY do begin
        for b:=1 to RealCursSizeX do begin
            if MPtr.Buf^[moffs]<>MPtr.TranspColor then
                    mem[offs]:=MPtr.Buf^[moffs];
            moffs:=moffs+1;
            offs:=offs+1;
        end;
        moffs:=moffs+padd;
        offs:=offs+xadd;
    end;

  {now draw part, that located right on the split screen}
    if SplitScrnDraw then begin
     {if starting window x address<>0 then}
 {we must currect cursor x coordinate, because split screen doesn't scrolling}
       x:=x-WindowPosX;
       Offs:=SplitScreen.seg+x+StartYOnSplitScrn*SplitScreen.SizeX;
       for a:=1 to YSizeOnSplitScrn do begin
           for b:=1 to RealCursSizeX do begin
              if MPtr.Buf^[moffs]<>MPtr.TranspColor then
                      mem[offs]:=MPtr.Buf^[moffs];
              moffs:=moffs+1;
              offs:=offs+1;
           end;
           moffs:=moffs+padd;
           offs:=offs+xadd;
       end;
    end;
 end;

Procedure RestoreMouseBK(x,y,WinX:integer);
 var a,b:integer;
     offs:dword;
     moffs:integer;
     xadd:dword;
     RealCursSizeX:integer;
     RealCursSizeY:integer;
     padd:dword;
     YSizeOnSplitScrn:integer;
     StartYOnSplitScrn:integer;
     CursSizeX,CursSizeY:integer;
     SplitScrnDraw:boolean;
 begin
    CursSizeX:=MPtr.SizeX;
    CursSizeY:=MPtr.SizeY;
    SplitScrnDraw:=false;

    offs:=WhereDraw.seg+(y*WhereDraw.SizeX+x)*BytesPerPixel;
    moffs:=0;

    if (x+CursSizeX)>ScrnSizeX then begin
       RealCursSizeX:=ScrnSizeX-x;
       padd:=CursSizeX-RealCursSizeX;
    end
    else begin
       RealCursSizeX:=CursSizeX;
       padd:=0;
    end;
    if (y+CursSizeY)>ScrnSizeY then RealCursSizeY:=ScrnSizeY-y
      else RealCursSizeY:=CursSizeY;

    if (SplitScrnActive AND DrawOverSplitScreen) then
{if cursor go over split screen, then we must draw part of cursor on split screen}
       if (y+RealCursSizeY)>SplitScrnScanLine then begin
          SplitScrnDraw:=True;
          {calculate number of rows must be displayed on split screen}
          YSizeOnSplitScrn:=RealCursSizeY-(SplitScrnScanLine-y);

          {all cursor located on split screen}
          if YSizeOnSplitScrn>RealCursSizeY then begin
             --RealCursSizeY:=SplitScrnScanLine-y;
             YSizeOnSplitScrn:=RealCursSizeY;
             RealCursSizeY:=0;
             StartYOnSplitScrn:=y-SplitScrnScanLine-1;
          end
          else begin
             StartYOnSplitScrn:=0;
--             YSizeOnSplitScrn-:=3;
             YSizeOnSplitScrn-:=1;
             RealCursSizeY:=RealCursSizeY-YSizeOnSplitScrn;
          end;
       end;



    xadd:=(WhereDraw.SizeX-RealCursSizeX);
    for a:=1 to RealCursSizeY do begin
        for b:=1 to RealCursSizeX do begin
            mem[offs]:=MPtr.BKBuf^[moffs];
            moffs:=moffs+1;
            offs:=offs+1;
        end;
        moffs:=moffs+padd;
        offs:=offs+xadd;
    end;

  {now draw part, that located right on the split screen}
    if SplitScrnDraw then begin
     {if starting window x address<>0 then}
 {we must currect cursor x coordinate, because split screen doesn't scrolling}
       x:=x-WinX;
       Offs:=SplitScreen.seg+x+StartYOnSplitScrn*SplitScreen.SizeX;
       for a:=1 to YSizeOnSplitScrn do begin
           for b:=1 to RealCursSizeX do begin
              mem[offs]:=MPtr.BKBuf^[moffs];
              moffs:=moffs+1;
              offs:=offs+1;
           end;
           moffs:=moffs+padd;
           offs:=offs+xadd;
       end;
    end;
 end;

Procedure SaveMouseBK(x,y,WinX:integer);
 var a,b:integer;
     offs:dword;
     moffs:integer;
     xadd:dword;
     RealCursSizeX:integer;
     RealCursSizeY:integer;
     padd:dword;
     YSizeOnSplitScrn:integer;
     StartYOnSplitScrn:integer;
     CursSizeX,CursSizeY:integer;
     SplitScrnDraw:boolean;
 begin
    CursSizeX:=MPtr.SizeX;
    CursSizeY:=MPtr.SizeY;
    SplitScrnDraw:=false;

    offs:=WhereDraw.seg+(y*WhereDraw.SizeX+x)*BytesPerPixel;
    moffs:=0;

    if (x+CursSizeX)>ScrnSizeX then begin
       RealCursSizeX:=ScrnSizeX-x;
       padd:=CursSizeX-RealCursSizeX;
    end
    else begin
       RealCursSizeX:=CursSizeX;
       padd:=0;
    end;
    if (y+CursSizeY)>ScrnSizeY then RealCursSizeY:=ScrnSizeY-y
      else RealCursSizeY:=CursSizeY;

    if (SplitScrnActive AND DrawOverSplitScreen) then
{if cursor go over split screen, then we must draw part of cursor on split screen}
       if (y+RealCursSizeY)>SplitScrnScanLine then begin
          SplitScrnDraw:=True;
          {calculate number of rows must be displayed on split screen}
          YSizeOnSplitScrn:=RealCursSizeY-(SplitScrnScanLine-y);

          {all cursor located on split screen}
          if YSizeOnSplitScrn>RealCursSizeY then begin
             --RealCursSizeY:=SplitScrnScanLine-y;
             YSizeOnSplitScrn:=RealCursSizeY;
             RealCursSizeY:=0;
             StartYOnSplitScrn:=y-SplitScrnScanLine-1;
          end
          else begin
             StartYOnSplitScrn:=0;
--             YSizeOnSplitScrn-:=3;
             YSizeOnSplitScrn-:=1;
             RealCursSizeY:=RealCursSizeY-YSizeOnSplitScrn;
          end;
       end;



    xadd:=(WhereDraw.SizeX-RealCursSizeX);
    for a:=1 to RealCursSizeY do begin
        for b:=1 to RealCursSizeX do begin
            MPtr.BKBuf^[moffs]:=mem[offs];
            moffs:=moffs+1;
            offs:=offs+1;
        end;
        moffs:=moffs+padd;
        offs:=offs+xadd;
    end;

  {now draw part, that located right on the split screen}
    if SplitScrnDraw then begin
     {if starting window x address<>0 then}
 {we must currect cursor x coordinate, because split screen doesn't scrolling}
       x:=x-WinX;
       Offs:=SplitScreen.seg+x+StartYOnSplitScrn*SplitScreen.SizeX;
       for a:=1 to YSizeOnSplitScrn do begin
           for b:=1 to RealCursSizeX do begin
              MPtr.BKBuf^[moffs]:=mem[offs];
              moffs:=moffs+1;
              offs:=offs+1;
           end;
           moffs:=moffs+padd;
           offs:=offs+xadd;
       end;
    end;
 end;

Procedure DefaultHandler(Mask,Buttons,x,y,movX,movY:word);
   begin
      {wait for vertical retrace}
--      while port[$3da] and 8 <>0 do;
--      while port[$3da] and 8 = 0 do;
      RestoreMouseBK(OldX,OldY,OldWinX);
      OldX:=x;
      OldY:=y;
      OldWinX:=WindowPosX;
      OldWinY:=WindowPosY;
      SaveMouseBK(OldX,OldY,OldWinX);
      DrawMousePointer(OldX,OldY);
   end;

Procedure SetMouseWindow(x1,y1,x2,y2:integer);
  begin
     MinX:=x1; MinY:=y1; MaxX:=x2; MaxY:=y2;
  end;

Procedure LoadMousePointer(var p:TMousePointer);
{allocate memory for background for this pointer}
  begin
    GetMem(p.BKBuf,p.SizeX*p.SizeY*BytesPerPixel);
  end;

Procedure SetMousePointer(p:TMousePointer);
  begin
    MPtr:=p;
  end;

Procedure FreeMousePointer(var p:TMousePointer);
  begin
    FreeMem(p.BKBuf,MPtr.SizeX*MPtr.SizeY*BytesPerPixel);
  end;

Procedure SetMouseWritePage(Where:TPageType);
  begin
    WhereDraw:=Where;
  end;

Procedure ShowMousePointer;
  begin
    OldX:=GetMouseX;
    OldY:=GetMouseY;
    OldWinX:=WindowPosX;
    OldWinY:=WindowPosY;
    SaveMouseBK(OldX,OldY,OldWinX);
    DrawMousePointer(OldX,OldY);
    SetMouseHandler(MovingOnly,DefaultHandler);
  end;

Procedure HideMousePointer;
  begin
    SetMouseHandler(MovingOnly,nil);
    RestoreMouseBK(OldX,OldY,OldWinX);
  end;

Procedure UpdateMousePointer;
{this procedure called SetStartAddr procedure, to update mouse pointer}
{result of this procedure visible only if DrawOverSplitScreen=true and}
{split screen active}
  begin
--    DrawMousePointer(GetMouseX,GetMouseY);
--    SetMousePos(GetMouseX+1,GetMouseY+1);
--    SetMousePos(OldX,OldY);
--    DefaultHandler(0,0,GetMouseX,GetMouseY,0,0);
  end;